StarObjectSpreadsheet Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
StarObjectSpreadsheet Class Referencefinal

the main class to read a StarOffice sdc file More...

`#include <StarObjectSpreadsheet.hxx>`

Inheritance diagram for StarObjectSpreadsheet:

## Public Member Functions
| StarObjectSpreadsheet (StarObject const &orig, bool duplicateState)
| constructor
| ~StarObjectSpreadsheet () final
| destructor
bool | parse ()
| try to parse the current object
bool | send (STOFFSpreadsheetListenerPtr listener)
| try to send the spreadsheet
bool | sendRow (int table, int row, STOFFSpreadsheetListenerPtr listener)
| try to send a spreadsheet row.
bool | sendCell (StarObjectSpreadsheetInternal::Cell &cell, StarAttribute *attrib, int table, int numRepeated, STOFFSpreadsheetListenerPtr listener)
| try to send a cell
bool | updatePageSpans (std::vector< STOFFPageSpan > &pageSpan, int &numPages)
| try to update the page span
Public Member Functions inherited from StarObject
| StarObject (char const *passwd, std::shared_ptr< STOFFOLEParser > &oleParser, std::shared_ptr< STOFFOLEParser::OleDirectory > &directory)
| constructor
virtual | ~StarObject ()
| destructor
bool | parse ()
| try to parse data
STOFFDocument::Kind | getDocumentKind () const
| returns the document kind
char const * | getPassword () const
| returns the document password (the password given by the user)
std::shared_ptr< STOFFOLEParser::OleDirectory > | getOLEDirectory ()
| returns the object directory
std::shared_ptr< StarAttributeManager > | getAttributeManager ()
| returns the attribute manager
std::shared_ptr< StarFormatManager > | getFormatManager ()
| returns the format manager
librevenge::RVNGPropertyList const & | getMetaData () const
| returns the meta data (filled by readSfxDocumentInformation)
librevenge::RVNGString | getUserNameMetaData (int i) const
| returns the ith user meta data
void | cleanPools ()
| clean each pool
std::shared_ptr< StarItemPool > | getNewItemPool (StarItemPool::Type type)
| returns a new item pool for this document
std::shared_ptr< StarItemPool > | findItemPool (StarItemPool::Type type, bool isInside)
| check if a pool corresponding to a given type is opened if so returned it.
std::shared_ptr< StarItemPool > | getCurrentPool (bool onlyInside=true)
| returns the current all/inside pool
bool | readPersistData (StarZone &zone, long endPos)
| try to read persist data
bool | readSfxStyleSheets (STOFFInputStreamPtr input, std::string const &name)
| try to read a spreadshet style zone: SfxStyleSheets
bool | readItemSet (StarZone &zone, std::vector< STOFFVec2i > const &limits, long endPos, StarItemSet &itemSet, StarItemPool *pool=nullptr, bool isDirect=false)
| try to read a list of item

## Protected Member Functions
bool | readCalcDocument (STOFFInputStreamPtr input, std::string const &fileName)
| try to read a spreadsheet zone: StarCalcDocument .sdc
bool | readSfxStyleSheets (STOFFInputStreamPtr input, std::string const &fileName)
| try to read a spreadshet style zone: SfxStyleSheets
bool | readSCTable (StarZone &zone, StarObjectSpreadsheetInternal::Table &table)
| try to read a SCTable
bool | readSCColumn (StarZone &zone, StarObjectSpreadsheetInternal::Table &table, int column, long lastPos)
| try to read a SCColumn
bool | readSCData (StarZone &zone, StarObjectSpreadsheetInternal::Table &table, int column)
| try to read a list of data
bool | readSCChangeTrack (StarZone &zone, int version, long lastPos)
| try to read a change trak
bool | readSCDBData (StarZone &zone, int version, long lastPos)
| try to read a dbData
bool | readSCDBPivot (StarZone &zone, int version, long lastPos)
| try to read a dbPivot
bool | readSCMatrix (StarZone &zone, int version, long lastPos)
| try to read a matrix
bool | readSCQueryParam (StarZone &zone, int version, long lastPos)
| try to read a query param
bool | readSCOutlineArray (StarZone &zone)
| try to read a SCOutlineArray
Protected Member Functions inherited from StarObject
bool | readPersistElements (STOFFInputStreamPtr input, std::string const &name)
| the "persist elements" small ole: the list of object
bool | readSfxDocumentInformation (STOFFInputStreamPtr input, std::string const &name)
| try to read the document information : "SfxDocumentInformation"
bool | readSfxPreview (STOFFInputStreamPtr input, std::string const &name)
| try to read the preview : "SfxPreview"
bool | readSfxWindows (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the windows information : "SfxWindows"
bool | readStarFrameworkConfigFile (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the "Star Framework Config File"
bool | readStarFrameworkConfigItem (STOFFEntry &entry, STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read an item in a "Star Framework Config File"
| StarObject (StarObject const &orig, bool duplicateState)
| copy constructor

## Protected Attributes
std::shared_ptr< StarObjectSpreadsheetInternal::State > | m_spreadsheetState
| the state
Protected Attributes inherited from StarObject
char const * | m_password
| the document password
std::shared_ptr< STOFFOLEParser > | m_oleParser
| the ole parser
std::shared_ptr< STOFFOLEParser::OleDirectory > | m_directory
| the directory
std::shared_ptr< StarObjectInternal::State > | m_state
| the state
librevenge::RVNGPropertyList | m_metaData
| the meta data

## Detailed Description

the main class to read a StarOffice sdc file

## Constructor & Destructor Documentation

## ◆ StarObjectSpreadsheet()

StarObjectSpreadsheet::StarObjectSpreadsheet | ( | StarObject const & | orig,
|  | bool | duplicateState )

constructor

Referenced by updatePageSpans().

## ◆ ~StarObjectSpreadsheet()

StarObjectSpreadsheet::~StarObjectSpreadsheet | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ parse()

bool StarObjectSpreadsheet::parse | ( |  | ) |

try to parse the current object

Referenced by StarFileManager::checkUnparsed(), SDXParser::createZones(), and StarFileManager::readOLEDirectory().

## ◆ readCalcDocument()

bool StarObjectSpreadsheet::readCalcDocument | ( | STOFFInputStreamPtr | input,
|  | std::string const & | fileName )
| protected

try to read a spreadsheet zone: StarCalcDocument .sdc

Referenced by parse().

## ◆ readSCChangeTrack()

bool StarObjectSpreadsheet::readSCChangeTrack | ( | StarZone & | zone,
|  | int | version,
|  | long | lastPos )
| protected

try to read a change trak

Referenced by readCalcDocument().

## ◆ readSCColumn()

bool StarObjectSpreadsheet::readSCColumn | ( | StarZone & | zone,
|  | StarObjectSpreadsheetInternal::Table & | table,
|  | int | column,
|  | long | lastPos )
| protected

try to read a SCColumn

Referenced by readSCTable().

## ◆ readSCData()

bool StarObjectSpreadsheet::readSCData | ( | StarZone & | zone,
|  | StarObjectSpreadsheetInternal::Table & | table,
|  | int | column )
| protected

try to read a list of data

Referenced by readSCColumn().

## ◆ readSCDBData()

bool StarObjectSpreadsheet::readSCDBData | ( | StarZone & | zone,
|  | int | version,
|  | long | lastPos )
| protected

try to read a dbData

Referenced by readCalcDocument().

## ◆ readSCDBPivot()

bool StarObjectSpreadsheet::readSCDBPivot | ( | StarZone & | zone,
|  | int | version,
|  | long | lastPos )
| protected

try to read a dbPivot

Referenced by readCalcDocument().

## ◆ readSCMatrix()

bool StarObjectSpreadsheet::readSCMatrix | ( | StarZone & | zone,
|  | int | version,
|  | long | lastPos )
| protected

try to read a matrix

Referenced by readCalcDocument().

## ◆ readSCOutlineArray()

bool StarObjectSpreadsheet::readSCOutlineArray | ( | StarZone & | zone | ) |
| protected

try to read a SCOutlineArray

Referenced by readSCTable().

## ◆ readSCQueryParam()

bool StarObjectSpreadsheet::readSCQueryParam | ( | StarZone & | zone,
|  | int | version,
|  | long | lastPos )
| protected

try to read a query param

Referenced by readCalcDocument(), and readSCDBPivot().

## ◆ readSCTable()

bool StarObjectSpreadsheet::readSCTable | ( | StarZone & | zone,
|  | StarObjectSpreadsheetInternal::Table & | table )
| protected

try to read a SCTable

Referenced by readCalcDocument().

## ◆ readSfxStyleSheets()

bool StarObjectSpreadsheet::readSfxStyleSheets | ( | STOFFInputStreamPtr | input,
|  | std::string const & | fileName )
| protected

try to read a spreadshet style zone: SfxStyleSheets

Referenced by parse().

## ◆ send()

bool StarObjectSpreadsheet::send | ( | STOFFSpreadsheetListenerPtr | listener | ) |

try to send the spreadsheet

Referenced by StarFileManager::readOLEDirectory().

## ◆ sendCell()

bool StarObjectSpreadsheet::sendCell | ( | StarObjectSpreadsheetInternal::Cell & | cell,
|  | StarAttribute * | attrib,
|  | int | table,
|  | int | numRepeated,
|  | STOFFSpreadsheetListenerPtr | listener )

try to send a cell

Referenced by sendRow().

## ◆ sendRow()

bool StarObjectSpreadsheet::sendRow | ( | int | table,
|  | int | row,
|  | STOFFSpreadsheetListenerPtr | listener )

try to send a spreadsheet row.

Note
  this function does not call openSheetRow,closeSheetRow

Referenced by send().

## ◆ updatePageSpans()

bool StarObjectSpreadsheet::updatePageSpans | ( | std::vector< STOFFPageSpan > & | pageSpan,
|  | int & | numPages )

try to update the page span

Referenced by StarFileManager::readOLEDirectory().

## Member Data Documentation

## ◆ m_spreadsheetState

std::shared_ptr<StarObjectSpreadsheetInternal::State> StarObjectSpreadsheet::m_spreadsheetState
| protected

the state

Referenced by readCalcDocument(), readSCTable(), send(), sendCell(), sendRow(), StarObjectSpreadsheet(), and updatePageSpans().

The documentation for this class was generated from the following files:

- StarObjectSpreadsheet.hxx
- StarObjectSpreadsheet.cxx